/**
 * Module dependencies.
 */

var express = require('express'),
	routes = require('./routes')

var app = module.exports = express.createServer();

// Configuration
app.configure(function(){
	app.use(express.bodyParser());
	app.use(express.methodOverride());
	app.use(express.jsonRPC2());
	app.use(app.router);
});

app.configure('development', function(){
	app.use(express.errorHandler({ dumpExceptions: true, showStack: true })); 
});

app.configure('production', function(){
	app.use(express.errorHandler()); 
});

// Routes
app.post('/', function (req, res, next) {
	res.rpc('subtract', function (params, respond) {
		var result;

		if ( Array.isArray(params) ) {
			result = params[0] - params[1];	
		} else if (typeof params === 'object' ) {
			result = params['param1'] - params['param2'];
		}

		if (typeof result === 'number') {
			respond( { result: result } );
		} else {
			respond({
				error: {
					code: 'INVALID_PARAMS'
				}
			});
		}
	});
});

app.listen(3000);
console.log("Express server listening on port %d in %s mode", app.address().port, app.settings.env);
